<script>
import Vue from 'vue';
import { SolutionsVideoCard as VideoCard } from '../solutions/index.vue';
import SlpHorizontalRule from './horizontal-rule.vue';
import { RESOURCE_ICON_PATH } from '~/common/constants.ts';

export default Vue.extend({
  name: 'CopyList',
  components: {
    SlpHorizontalRule,
    VideoCard,
  },
  props: {
    data: {
      type: Object,
      required: true,
    },
  },
  computed: {
    resourceIcon() {
      return RESOURCE_ICON_PATH;
    },
  },
});
</script>

<template>
  <SlpContainer>
    <div
      v-for="(block, index) in data.block"
      :key="index"
      class="container"
      :class="{ 'no-hr-margin': data.hide_horizontal_rule }"
    >
      <span v-if="block.metadata" :id="block.metadata.id_tag || ''"></span>
      <div class="copy">
        <SlpTypography tag="h2" variant="heading3" class="slp-mb-16"
          >{{ block?.title ? block?.title : 'Resources' }}
        </SlpTypography>
        <SlpTypography v-if="block.subtitle" tag="h3" variant="heading5"
          >{{ block.subtitle }}
        </SlpTypography>
        <div class="copy__body">
          <div
            v-if="block.text"
            class="slp-mb-32"
            v-html="$md.render(block.text)"
          ></div>
          <slp-button
            v-if="block.link_href"
            :href="block.link_href"
            :data-ga-name="block.data_ga_name"
            :data-ga-location="block.data_ga_location"
            >{{ block.link_text }}
          </slp-button>
        </div>
        <div v-if="block.video" class="video-container">
          <video-card :video="block.video" />
          <a
            href="https://www.youtube.com/channel/UCnMGQ8QHMAnVIsI3xJrihhg/featured"
            class="more-videos"
          >
            <SlpTypography variant="body2">View more videos →</SlpTypography>
          </a>
        </div>
      </div>
      <div class="resources">
        <SlpHorizontalRule />
        <div
          v-for="(resource, propertyName, resourceIndex) in block.resources"
          :key="propertyName"
          class="slp-flex slp-flex-column"
        >
          <div class="slp-flex">
            <SlpIcon
              v-if="resourceIcon[propertyName]"
              class="slp-mr-24"
              :name="resourceIcon[propertyName]"
              alt=""
              size="sm"
              variant="marketing"
              slp-color="accent-500"
            />
            <SlpTypography tag="h4" variant="body1" class="bold"
              >{{ resource.header }}
            </SlpTypography>
          </div>
          <!-- eslint-disable vue/no-template-shadow -->
          <a
            v-for="(link, index) in resource.links"
            :key="`${propertyName}-${index}`"
            class="slp-mb-16 slp-mt-16"
            :href="link.link"
            :data-ga-name="link.data_ga_name"
            :data-ga-location="link.data_ga_location"
          >
            <SlpTypography variant="body1"> {{ link.text }} →</SlpTypography>
          </a>
          <!-- eslint-enable vue/no-template-shadow -->
          <SlpHorizontalRule
            v-if="
              Object.keys(block.resources).length - 1 !== resourceIndex ||
              data.hide_horizontal_rule
            "
          />
        </div>
      </div>
      <SlpHorizontalRule v-if="!data.hide_horizontal_rule" />
    </div>
  </SlpContainer>
</template>

<style lang="scss" scoped>
.bold {
  font-weight: bold !important;
}

.container {
  display: grid;
  grid-template-columns: repeat(4, 1fr);
  padding: 0 15px;
  grid-gap: 15px;
  margin: 0 auto;
  max-width: 100%;
  position: relative;
  padding-top: 30px;

  &.no-hr-margin {
    margin-bottom: 132px;
  }

  @media (min-width: $breakpoint-lg) {
    grid-template-columns: repeat(12, 1fr);
    grid-auto-flow: column;
  }

  hr {
    margin: 30px 0;
    grid-column: 1 / span 12;
  }

  &__corner-img {
    position: absolute;
    left: -30px;
    top: -25px;

    @media (max-width: $breakpoint-sm) {
      left: 0;
    }
  }
}

.video-container {
  display: flex;
  flex-direction: column;
  align-items: center;

  .more-videos {
    text-align: center;
    width: 100%;
    margin-top: $spacing-32;

    &:hover {
      text-decoration: underline;
    }
  }
}

.copy {
  grid-column: 1 / 12;

  @media (min-width: $breakpoint-lg) {
    grid-column: 1 / 6;
  }

  h3 {
    color: $color-text-300;
    font-weight: 400;
    margin-bottom: 16px;
  }

  &__body {
    grid-column: 1 / 12;
    color: $color-text-300;

    &:deep p {
      margin-bottom: 1em;
    }

    &:deep p a {
      color: $color-text-link-100;
    }
  }
}

.resources {
  grid-column: 1 / 12;

  @media (min-width: $breakpoint-lg) {
    grid-column: 7 / span 6;
  }

  &__icon {
    max-width: 24px;
    vertical-align: middle;
    margin-right: 20px;
  }

  a {
    margin-left: 44px;

    &:hover {
      text-decoration: underline;
    }
  }
}
</style>
